<template>
    <div class="app-container">
        <el-row :gutter="20" type="flex" justify="center" align="middle">
            <el-col :lg="10" :md="10" :sm="24" align="middle" class="paper" v-loading="accountLoading">
                <el-form ref="accountForm" :model="accountForm" :rules="accountRules">
                    <h3>My Account</h3>
                    <aside>
                        <el-alert type="info" title="Your account information" :closable=false show-icon></el-alert>
                    </aside>
                    <el-form-item label="Full name" prop="fullname">
                        <el-input 
                            ref="fullname" 
                            name="fullname" 
                            v-model="accountForm.fullname" 
                            placeholder="Your full name" 
                            autocomplete="off" 
                            maxlength="45" 
                            show-word-limit>
                        </el-input>
                    </el-form-item>
                    <el-form-item label="Badge" prop="badge">
                        <el-input 
                            ref="badge" 
                            name="badge" 
                            v-model="accountForm.badge" 
                            placeholder="Your company badge number" 
                            autocomplete="off" 
                            maxlength="25" 
                            show-word-limit>
                        </el-input>
                    </el-form-item>
                    <el-form-item label="Phone" prop="phone">
                        <el-input 
                            ref="phone" 
                            name="phone" 
                            v-model="accountForm.phone" 
                            placeholder="Your mobile phone number" 
                            autocomplete="off" 
                            maxlength="25" 
                            show-word-limit>
                        </el-input>
                    </el-form-item>
                    <el-form-item class="text-align-left">
                        <el-button @click="doSubmit()" size="medium" type="primary" style="font-size:14px;">
                            <i class="ion-ios-checkmark-circle-outline"></i> Save
                        </el-button>
                    </el-form-item>                                 
                </el-form>
            </el-col>
        </el-row>        
    </div>
</template>
<script>
import { mapGetters } from 'vuex';
import { parseError } from '../../utils/index';
export default {
    name: 'Account',
    data() {
        return {
            accountLoading: false,
            accountForm: {
                fullname: '',
                badge: '',
                phone: ''
            },
            accountRules: {
                fullname: [{ 
                    required: true, message: 'Full name is required', trigger: 'blur'
                }, {
                    max: 255, message: 'Full name maximum 255 characters', trigger: 'blur'
                }, {
                    pattern: /^([a-zA-Z\s]{1,255})$/, 
                    message: 'Only letters and spaces are allowed', 
                    trigger: 'blur'
                }],
                phone: [{
                    required: true, message: 'Phone number is required', trigger: 'blur'
                },{
                    max: 25, message: 'Phone number maximum 25 characters', trigger: 'blur'
                }, {
                    pattern: /\(?(?:\+628|628|08)(?:\d{2,3})?\)?[ .-]?\d{2,4}[ .-]?\d{2,4}[ .-]?\d{2,4}/, 
                    message: 'Invalid phone number', 
                    trigger: 'blur'
                }],
            }
        }
    },
    computed: {
        ...mapGetters('user', ['me']),
    },
    created(){
        const self = this;
        self.accountForm.fullname = self.me.fullname;
        self.accountForm.badge = self.me.badge;
        self.accountForm.phone = self.me.phone;
    },
    methods: {
        doSubmit(){
            const self = this;

            self.$refs.accountForm.validate((valid) => {
                if(valid){

                    self.accountLoading = true;

                    self.$store.dispatch('user/editMe', {
                        fullname: self.accountForm.fullname,
                        badge: self.accountForm.badge,
                        phone: self.accountForm.phone
                    }).then((response)=>{

                        self.accountLoading = false;

                        if('errors' in response){
                            let error = parseError(response.errors);
                            self.$message.error({
                                message: error.messages
                            });
                        }else{
                            self.$message.success({
                                message: response.message
                            });
                        }
                    });
                }else{
                    return false;
                }
            });
        }
    }
}
</script>